dnl -*- m4 -*-
dnl
dnl  This file is part of WEEVIL.
dnl
dnl  Authors: See the file AUTHORS for full details.
dnl
dnl  Copyright (C) 2002-2006 University of Colorado
dnl
dnl  Weevil is free software: you can redistribute it and/or modify
dnl  it under the terms of the GNU General Public License as published by
dnl  the Free Software Foundation, either version 3 of the License, or
dnl  (at your option) any later version.
dnl
dnl  Weevil is distributed in the hope that it will be useful,
dnl  but WITHOUT ANY WARRANTY; without even the implied warranty of
dnl  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
dnl  GNU General Public License for more details.
dnl
dnl  You should have received a copy of the GNU General Public License
dnl  along with Weevil.  If not, see <http://www.gnu.org/licenses/>.
dnl
dnl
dnl
dnl ======================control==========================
dnl
define(`forloop',`pushdef(`$1',`$2')_forloop(`$1',`$2',`$3',`$4')popdef(`$1')')dnl
define(`_forloop',`$4`'ifelse($1, `$3',,`define(`$1',incr($1))_forloop(`$1',`$2',`$3',`$4')')')dnl
dnl
define(`WVL_SYS_Range', `ifelse($2, $3, `$1'$2, `ifelse(eval($3>$2), 1, `forloop(`i', $2, decr($3), ``$1'i, ')$1$3', `')')')dnl
dnl
define(`WVL_SYS_Echo', `$1')dnl
dnl
dnl WVL_SYS_Head	-- Returns the "head" of its argument list.
dnl
define( `WVL_SYS_Head', ``$1'')dnl
dnl
dnl WVL_SYS_Tail	-- Returns the "rest" of its argument list.
dnl
define( `WVL_SYS_Tail', `shift($@)')dnl
dnl
dnl WVL_SYS_Add		-- Defines or redefines the first argument to
dnl			   be its previous contents with additional arguments
dnl			   appended.
dnl
define( `WVL_SYS_Add', `ifdef(`$1',`pushdef( `tmp', defn(`$1')`,shift($@)')'`define( `$1', defn(`tmp'))'`popdef(`tmp')',`define(`$1', `shift($@)')')')dnl
dnl
dnl WVL_SYS_Contains	-- Checks if the first argument is contained by the
dnl			   list representing the rest of the arguments
dnl
define( `WVL_SYS_Contains',`ifelse( len(`$2'), 0, `false', `ifelse( `$2', `$1', `true', `WVL_SYS_Contains( `$1', shift(shift($@)))')')')dnl
dnl
dnl WVL_SYS_Insert	-- Adds the second argument to the first argument, if it
dnl		           doesn't already exist there.
define( `WVL_SYS_Insert', `ifelse( len( `$2'), 0, , `ifelse( WVL_SYS_Contains( `$2', $1), `true', , `WVL_SYS_Add( `$1', `$2')')WVL_SYS_Insert( `$1', shift(shift($@)))')')dnl
dnl
dnl WVL_SYS_Callforeach	-- Applies first argument to second argument and
dnl			   then processes the rest recursively
dnl
define( `WVL_SYS_Callforeach',dnl
`ifelse( len($2), 0, , `$1(``$2'')'`WVL_SYS_Callforeach( `$1', shift(shift($@)))')')dnl
dnl
dnl WVL_SYS_Foreach	-- Iterates over arguments 3-* defining $1 to the current value and
dnl			   executing $2.
dnl
dnl WVL_SYS_Foreach( `i', ``i' is set to i', `a', `b', `123', `this,is')
define( `WVL_SYS_Foreach',dnl
`ifelse( len(`$3'), 0, , `pushdef( `$1', `$3')$2`'WVL_SYS_Foreach( `$1', `$2', shift(shift(shift($@))))popdef( `$1')')')dnl
dnl
dnl WVL_SYS_Fortwo	-- Iterates over arguments 4-* defining $1 to the current value and
dnl			   $2 to the next value and executing $3.
dnl
dnl WVL_SYS_Fortwo( `i', `j', ``i' is set to i, `j' is set to j', `a', `b', `123', `this,is')
define( `WVL_SYS_Fortwo',dnl
`ifelse( len(`$4'), 0, , len(`$5'), 0, , `pushdef( `$1', `$4')pushdef( `$2', `$5')$3`'dnl
WVL_SYS_Fortwo( `$1', `$2', `$3', shift(shift(shift(shift(shift($@))))))popdef( `$1')popdef( `$2')')')dnl
dnl
dnl WVL_SYS_First	-- Return the first value in the argument
dnl
dnl WVL_SYS_First(`1, 2, 3')
define(`WVL_SYS_First', $1)dnl
dnl
dnl WVL_SYS_Fortwovar	-- Iterates over arguments 4 and 5 defining $1 to the current value and
dnl			   $2 to the next value and executing $3.
dnl
dnl WVL_SYS_Fortwovar( `i', `j', ``i' is set to i, `j' is set to j', `a, b, c', `1, 2, 3')
define(`WVL_SYS_Fortwovar', dnl
`ifelse( len(WVL_SYS_First($4)), 0, , len(WVL_SYS_First($5)), 0, , `pushdef(`$1', WVL_SYS_First($4))pushdef(`$2', WVL_SYS_First($5))$3`'dnl
WVL_SYS_Fortwovar(`$1', `$2', `$3', `shift($4)', `shift($5)')popdef( `$1')popdef( `$2')')')
dnl
dnl WVL_SYS_Subst_Commas -- Iterates over arguments replacing commas with $1
dnl
define( `WVL_SYS_Subst_Commas',dnl
``$2'`$1'ifelse( len(`$3'), 0, `', `WVL_SYS_Subst_Commas( `$1', shift(shift($@)))')')dnl
dnl
dnl WVL_SYS_Strip_Commas -- Iterates over arguments expanding without commas
dnl
define( `WVL_SYS_Strip_Commas', `WVL_SYS_Subst_Commas( ` ', $@)')dnl
dnl
dnl ============definitions============
dnl
dnl ***WVL_SYS_Actor***
dnl $1 -- ID
dnl $2 -- workloadProcess
dnl $3 -- program
dnl $4 -- entity
dnl $5 -- directory
dnl
define(WVL_SYS_Actor, `define(`WVL_Actor_'$1)dnl
define(`WVL_Entity_'$1)dnl
define(`WVL_Actor_'$1`_workloadProcess', $2)dnl
define(`WVL_Actor_'$1`_program', $3)dnl
define(`WVL_Actor_'$1`_entity', $4)dnl
define(`WVL_Actor_'$1`_dir', $5)')dnl
dnl
dnl ***WVL_SYS_ActorProgram***
dnl $1 -- ID
dnl $2 -- style
dnl $3 -- binaryDistDir
dnl $4 -- program
dnl $5 -- argument
dnl $6 -- classpath
dnl $7 -- logs
dnl $8 -- receiveProgram
dnl
define(WVL_SYS_ActorProgram, `define(`WVL_ActorProgram_'$1)dnl
define(`WVL_ActorProgram_'$1`_style', $2)dnl
define(`WVL_ActorProgram_'$1`_binaryDistDir', $3)dnl
define(`WVL_ActorProgram_'$1`_program', $4)dnl
define(`WVL_ActorProgram_'$1`_argument', $5)dnl
define(`WVL_ActorProgram_'$1`_classpath', $6)dnl
define(`WVL_ActorProgram_'$1`_logs', `$7')dnl
define(`WVL_ActorProgram_'$1`_receiveProgram', $8)')dnl
dnl
dnl ***WVL_SYS_ActorProp***
dnl $1 -- actorID
dnl $2 -- propertyName
dnl $3 -- propertyValue
dnl
define(WVL_SYS_ActorProp, `define(`WVL_Actor_'$1`_'$2, $3)dnl
WVL_SYS_Insert( `WVL_Actor_'$1`_props', $2)')dnl
dnl
dnl ***WVL_SYS_Component***
dnl $1 -- ID
dnl $2 -- type
dnl
define(WVL_SYS_Component, `define(`WVL_Component_'$1)dnl
define(`WVL_Entity_'$1)dnl
define(`WVL_Component_'$1`_type', $2)')dnl
dnl
dnl ***WVL_SYS_ComponentHost***
dnl $1 -- ID
dnl $2 -- component
dnl $3 -- host
dnl
define(WVL_SYS_ComponentHost, `define(`WVL_ComponentHost_'$1)dnl
define(`WVL_ComponentHost_'$1`_component', $2)dnl
define(`WVL_ComponentHost_'$1`_host', $3)')dnl
dnl
dnl ***WVL_SYS_ComponentHostProp***
dnl $1 -- componentHostID
dnl $2 -- propertyName
dnl $3 -- propertyValue
dnl
define(WVL_SYS_ComponentHostProp, `define(`WVL_ComponentHost_'$1`_'$2, $3)dnl
WVL_SYS_Insert(`WVL_ComponentHost_'$1`_props', $2)')dnl
dnl
dnl ***WVL_SYS_ComponentHostType***
dnl $1 -- componentType
dnl $2 -- hostType
dnl $3 -- binaryDistDir
dnl
define(WVL_SYS_ComponentHostType, `define(`WVL_ComponentHostType_'$1`_'$2)dnl
define(`WVL_ComponentHostType_'$1`_'$2`_binaryDistDir', $3)')dnl
dnl
dnl ***WVL_SYS_ComponentHostTypeProp***
dnl $1 -- componentType
dnl $2 -- hostType
dnl $3 -- propertyName
dnl $4 -- propertyValue
dnl
define(WVL_SYS_ComponentHostTypeProp, `define(`WVL_ComponentHostType_'$1`_'$2`_'$3, $4)dnl
WVL_SYS_Insert(`WVL_ComponentHostType_'$1`_'$2`_props', $3)')dnl
dnl
dnl ***WVL_SYS_ComponentOrder***
dnl $1 -- ID
dnl $2 -- sequence
dnl
define(WVL_SYS_ComponentOrder, `define(`WVL_ComponentOrder_'$1)dnl
define(`WVL_ComponentOrder_'$1`_sequence', `$2')')dnl
dnl
dnl ***WVL_SYS_ComponentPreStart***
dnl $1 -- ID
dnl $2 -- component IDs
dnl
define(WVL_SYS_ComponentPreStart, `define(`WVL_ComponentPreStart_'$1)dnl
define(`WVL_ComponentPreStart_'$1`_components', `$2')')dnl
dnl
dnl ***WVL_SYS_ComponentProp***
dnl $1 -- componentID
dnl $2 -- propertyName
dnl $3 -- propertyValue
dnl
define(WVL_SYS_ComponentProp, `define(`WVL_Component_'$1`_'$2, $3)dnl
WVL_SYS_Insert( `WVL_Component_'$1`_props', $2)')dnl
dnl
dnl ***WVL_SYS_ComponentRelation***
dnl $1 -- ID
dnl $2 -- name
dnl $3 -- src
dnl $4 -- dest
dnl
define(WVL_SYS_ComponentRelation, `define(`WVL_ComponentRelation_'$1)dnl
define(`WVL_ComponentRelation_'$1`_name', $2)dnl
define(`WVL_ComponentRelation_'$1`_src', $3)dnl
define(`WVL_ComponentRelation_'$1`_dest', $4)')dnl
dnl
dnl ***WVL_SYS_ComponentRelationProp***
dnl $1 -- componentRelationID
dnl $2 -- propertyName
dnl $3 -- propertyValue
dnl
define(WVL_SYS_ComponentRelationProp, `define(`WVL_ComponentRelation_'$1`_'$2, $3)dnl
WVL_SYS_Insert(`WVL_ComponentRelation_'$1`_props', $2)')dnl
dnl
dnl ***WVL_SYS_ComponentType***
dnl $1 -- ID
dnl $2 -- startScript
dnl $3 -- stopScript
dnl $4 -- startArgs
dnl $5 -- config
dnl $6 -- logs
dnl
define(WVL_SYS_ComponentType, `define(`WVL_ComponentType_'$1)dnl
define(`WVL_ComponentType_'$1`_startScript', $2)dnl
define(`WVL_ComponentType_'$1`_stopScript', $3)dnl
define(`WVL_ComponentType_'$1`_startArgs', $4)dnl
define(`WVL_ComponentType_'$1`_config', $5)dnl
define(`WVL_ComponentType_'$1`_logs', `$6')')dnl
dnl
dnl ***WVL_SYS_ComponentTypeProp***
dnl $1 -- componentTypeID
dnl $2 -- propertyName
dnl $3 -- propertyValue
dnl
define(WVL_SYS_ComponentTypeProp, `define(`WVL_ComponentType_'$1`_'$2, $3)dnl
WVL_SYS_Insert(`WVL_ComponentType_'$1`_'props, $2)')dnl
dnl
dnl ***WVL_SYS_Experiment***
dnl $1 -- ID : Experiment.ID
dnl $2 -- workload : Experiment Workload Id
dnl $3 -- actors : Experiment Actor Component Mapping
dnl $4 -- testbed : Experiment Testbed
dnl $5 -- sue : System under experiment
dnl $6 -- componentHosts : Experiment Component Host Mapping
dnl $7 -- clean : Remove the workspace of the experiment or not(`Y' or `N')
dnl $8 -- parallel : the number of parallel processes for remote communication and deployment
dnl $9 -- monitors : entity monitors
dnl $10 -- timeout : experiment length
dnl $11 -- testbedload : Faults 
dnl $12 -- injectors : Fault Injectors
dnl
define(`WVL_SYS_Experiment', `define(`WVL_Experiment_ID', $1)dnl
define(`WVL_Experiment_'$1`_workload', $2)dnl
define(`WVL_Experiment_'$1`_actors', `$3')dnl
define(`WVL_Experiment_'$1`_testbed', $4)dnl
define(`WVL_Experiment_'$1`_sue', $5)dnl
define(`WVL_Experiment_'$1`_componentHosts', `$6')dnl
define(`WVL_Experiment_'$1`_clean', $7)dnl
define(`WVL_Experiment_'$1`_parallel', $8)dnl
define(`WVL_Experiment_'$1`_monitors', `$9')dnl
define(`WVL_Experiment_'$1`_timeout', $10)dnl
define(`WVL_Experiment_'$1`_testbedload', $11)dnl
define(`WVL_Experiment_'$1`_injectors', `$12')')dnl
dnl
dnl ***WVL_SYS_Host***
dnl $1 -- ID : Host Id
dnl $2 -- address : Host Network Address
dnl $3 -- account : Account on the address
dnl $4 -- bourneShell : shell dir on host $2
dnl $5 -- java : path to java on host $2
dnl $6 -- weevilRoot : Weevil Root dir on host $2
dnl $7 -- type : Host Type
dnl
define(WVL_SYS_Host, `define(`WVL_Host_'$1)dnl
define(`WVL_Entity_'$1)dnl
define(`WVL_EntityHost_'$1`_host', $1)dnl
define(`WVL_Host_'$1`_address', $2)dnl
define(`WVL_Host_'$1`_account', $3)dnl
define(`WVL_Host_'$1`_bourneShell', $4)dnl
define(`WVL_Host_'$1`_java', $5)dnl
define(`WVL_Host_'$1`_weevilRoot', $6)dnl
define(`WVL_Host_'$1`_type', $7)')dnl
dnl
dnl ***WVL_SYS_HostProp***
dnl $1 -- hostID
dnl $2 -- propertyName
dnl $3 -- propertyValue
dnl
define(WVL_SYS_HostProp, `define(`WVL_Host_'$1`_'$2, $3)dnl
WVL_SYS_Insert(`WVL_Host_'$1`_props', $2)')dnl
dnl
dnl ***WVL_SYS_HostType***
dnl $1 -- ID : Type ID
dnl
define(WVL_SYS_HostType, `define(`WVL_HostType_'$1)')dnl
dnl
dnl ***WVL_SYS_Monitor***
dnl $1 -- ID
dnl $2 -- program
dnl $3 -- entity
dnl $4 -- directory
dnl
define(WVL_SYS_Monitor, `define(`WVL_Monitor_'$1)dnl
define(`WVL_Monitor_'$1`_program', $2)dnl
define(`WVL_Monitor_'$1`_entity', $3)dnl
define(`WVL_Monitor_'$1`_dir', $4)')dnl
dnl
dnl ***WVL_SYS_MonitorProgram***
dnl $1 -- ID
dnl $2 -- binaryDistDir
dnl $3 -- program
dnl $4 -- argument
dnl
define(WVL_SYS_MonitorProgram, `define(`WVL_MonitorProgram_'$1)dnl
define(`WVL_MonitorProgram_'$1`_binaryDistDir', $2)dnl
define(`WVL_MonitorProgram_'$1`_program', $3)dnl
define(`WVL_MonitorProgram_'$1`_argument', $4)')dnl
dnl
dnl ***WVL_SYS_MonitorProp***
dnl $1 -- monitorID
dnl $2 -- propertyName
dnl $3 -- propertyValue
dnl
define(WVL_SYS_MonitorProp, `define(`WVL_Monitor_'$1`_'$2, $3)dnl
WVL_SYS_Insert( `WVL_Monitor_'$1`_props', $2)')dnl
dnl
dnl ***WVL_SYS_SUE***
dnl $1 -- ID
dnl $2 -- components
dnl $3 -- relations
dnl $4 -- order
dnl $5 -- prestart
dnl
define(`WVL_SYS_SUE', `define(`WVL_SUE_'$1)dnl
define(`WVL_SUE_'$1`_components', `$2')dnl
define(`WVL_SUE_'$1`_relations', `$3')dnl
define(`WVL_SUE_'$1`_order', `$4')dnl
define(`WVL_SUE_'$1`_prestart', `$5')')dnl
dnl
dnl ***WVL_SYS_TestBed***
dnl $1 -- ID : Testbed Id
dnl $2 -- hosts
dnl
define(`WVL_SYS_Testbed', `define(`WVL_Testbed_'$1)dnl
define(`WVL_Testbed_'$1_`hosts', `$2')')dnl
dnl
dnl ***WVL_SYS_Workload***
dnl	$1 -- ID
dnl	$2 -- filename : file to store the workload.
dnl	$3 -- processes : list of WorkloadProcess ids
dnl
define( `WVL_SYS_Workload',`define( `WVL_Workload_'$1)dnl
define( `WVL_Workload_'$1`_filename', `$2')dnl
define( `WVL_Workload_'$1`_processes', `$3')')dnl
dnl
dnl $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
dnl
dnl ***WVL_SYS_Testbedload***
dnl	$1 -- ID
dnl	$2 -- filename : file to store the faults to the testbed.
dnl	$3 -- processes : list of Injector Process ids
dnl
dnl define( `WVL_SYS_Testbedload',`define( `WVL_Testbedload_'$1)dnl
dnl define( `WVL_Testbedload_'$1`_filename', `$2')dnl
dnl define( `WVL_Testbedload_'$1`_processes', `$3')')dnl
dnl
dnl ***WVL_SYS_Injector***
dnl $1 -- ID
dnl $2 -- injectProcess
dnl $3 -- program
dnl $4 -- entity
dnl $5 -- directory
dnl $6 -- logs
dnl
dnl define(WVL_SYS_Injector, `define(`WVL_Injector_'$1)dnl
dnl define(`WVL_Injector_'$1`_injectProcess', $2)dnl
dnl define(`WVL_Injector_'$1`_program', $3)dnl
dnl define(`WVL_Injector_'$1`_entity', $4)dnl
dnl define(`WVL_Injector_'$1`_dir', $5)dnl
dnl define(`WVL_Injector_'$1`_logs', $6)')dnl
dnl
dnl ***WVL_SYS_InjectorProgram***
dnl $1 -- ID
dnl $2 -- style
dnl $3 -- binaryDistDir
dnl $4 -- program
dnl $5 -- argument
dnl $6 -- classpath
dnl $7 -- receiveProgram
dnl
dnl define(WVL_SYS_InjectorProgram, `define(`WVL_InjectorProgram_'$1)dnl
dnl define(`WVL_InjectorProgram_'$1`_style', $2)dnl
dnl define(`WVL_InjectorProgram_'$1`_binaryDistDir', $3)dnl
dnl define(`WVL_InjectorProgram_'$1`_program', $4)dnl
dnl define(`WVL_InjectorProgram_'$1`_argument', $5)dnl
dnl define(`WVL_InjectorProgram_'$1`_classpath', $6)dnl
dnl define(`WVL_InjectorProgram_'$1`_receiveProgram', $7)')dnl
dnl
dnl ***WVL_SYS_InjectorProp***
dnl $1 -- injectorID
dnl $2 -- propertyName
dnl $3 -- propertyValue
dnl
dnl define(WVL_SYS_InjectorProp, `define(`WVL_Injector_'$1`_'$2, $3)dnl
dnl WVL_SYS_Insert( `WVL_Injector_'$1`_props', $2)')dnl
dnl
