# -*- sh -*-
#
#  This file is part of WEEVIL.
#
#  Authors: See the file AUTHORS for full details.
#
#  Copyright (C) 2002-2006 University of Colorado
#
#  Weevil is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  Weevil is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with Weevil.  If not, see <http://www.gnu.org/licenses/>.
#
#
#
# this script is called by an actor when it wishes to issue a RPC to other actors.
# this script must be called following the weevil communication script.
#
#!/bin/sh
#
# check the arguments
#
if [ $# -ne 2 ]
then
        echo "parameter error: You have $# arugment(s) instead of 2."
        echo "usage: sh weevil-sendMessage.sh <local path> <file name listing targets>"
        exit
elif [ ! -f $1/$2 ]
then
        echo "parameter error: The file you refer in the 2th argument does not exist."
        echo "usage: sh weevil-sendMessage.sh <local path> <file name listing targets>"
        exit
fi
#
# decide the line number of the target file
#
linenum=`cat $1/$2 | wc -l`
enterornot=`tail -n 1 $1/$2 | wc -l`
if [ $enterornot -eq 0 ]
then
    linenum=`expr $linenum + 1`
fi
#
# send out the message in parallel
#
shift
shift
$1/vxargs -p -y -P $linenum -a $1/sendmessagetasks -o $1/sendmessageoutput ssh {} $* &
