dnl -*- m4 -*-
dnl
dnl  This file is part of WEEVIL.
dnl
dnl  Authors: See the file AUTHORS for full details.
dnl
dnl  Copyright (C) 2002-2006 University of Colorado
dnl
dnl  Weevil is free software: you can redistribute it and/or modify
dnl  it under the terms of the GNU General Public License as published by
dnl  the Free Software Foundation, either version 3 of the License, or
dnl  (at your option) any later version.
dnl
dnl  Weevil is distributed in the hope that it will be useful,
dnl  but WITHOUT ANY WARRANTY; without even the implied warranty of
dnl  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
dnl  GNU General Public License for more details.
dnl
dnl  You should have received a copy of the GNU General Public License
dnl  along with Weevil.  If not, see <http://www.gnu.org/licenses/>.
dnl
dnl
dnl
dnl ===========Master Script=============
dnl
define(`theExperiment', `WVL_Experiment_ID')dnl
define(`theWorkload', `WVL_Experiment_'theExperiment`_workload')dnl
define(`theActors', `WVL_Experiment_'theExperiment`_actors')dnl
dnl
ifdef(`WVL_Experiment_'theExperiment`_testbedload', dnl
`define(`theInjectors', `WVL_Experiment_'theExperiment`_injectors')', `define(`theInjectors', `')')dnl
dnl
ifdef(`WVL_Experiment_'theExperiment`_monitors', dnl
`define(`theMonitors', `WVL_Experiment_'theExperiment`_monitors')', `define(`theMonitors', `')')dnl
define(`theTestbed', `WVL_Experiment_'theExperiment`_testbed')dnl
define(`theSUE', `WVL_Experiment_'theExperiment`_sue')dnl
define(`theParallel', `WVL_Experiment_'theExperiment`_parallel')dnl
define(`theTimeout', `WVL_Experiment_'theExperiment`_timeout')dnl
define(`theComponentHosts', `WVL_Experiment_'theExperiment`_componentHosts')dnl
define(`theComponents', `WVL_SUE_'theSUE`_components')dnl
define(`thePreStartComponents', `WVL_ComponentPreStart_'WVL_SYS_Echo(`WVL_SUE_'theSUE`_prestart')`_components')dnl
define(`theRelations', `WVL_SUE_'theSUE`_relations')dnl
dnl
WVL_SYS_Foreach(`i', `ifelse(len(WVL_SYS_Echo(`WVL_Actor_'i`_workloadProcess')), 0, `', dnl
`WVL_SYS_Insert(`theLoadActors', i)')dnl
ifelse(len(`WVL_ActorProgram_'WVL_SYS_Echo(`WVL_Actor_'i`_program')`_logs'), 0, `', dnl
`WVL_SYS_Insert(`theLogActors', i)')', theActors)dnl
dnl
WVL_SYS_Foreach(`i', `ifelse(len(WVL_SYS_Echo(`WVL_Actor_'i`_workloadProcess')), 0, `', dnl
`WVL_SYS_Insert(`theLoadInjectors', i)')dnl
ifelse(len(`WVL_ActorProgram_'WVL_SYS_Echo(`WVL_Actor_'i`_program')`_logs'), 0, `', dnl
`WVL_SYS_Insert(`theLogInjectors', i)')', theInjectors)dnl
dnl
ifdef(`theLoadActors',, `define(`theLoadActors', `')')dnl
ifdef(`theLoadInjectors',, `define(`theLoadInjectors', `')')dnl
ifdef(`theLogActors',, `define(`theLogActors', `')')dnl
ifdef(`theLogInjectors',, `define(`theLogInjectors', `')')dnl
dnl 
WVL_SYS_Foreach(`i', `ifelse(WVL_SYS_Contains(i, thePreStartComponents), `true', , dnl
`WVL_SYS_Insert(`theJoinComponents', i)')', theComponents)dnl
dnl
ifdef(`theJoinComponents',, `define(`theJoinComponents', `')')dnl
dnl
WVL_SYS_Foreach(`i', `define(`lognum', 0)WVL_SYS_Foreach(`j', `WVL_SYS_Insert(`theActorLogs', i`_'lognum)define(`lognum', incr(lognum))', dnl
WVL_SYS_Echo(`WVL_ActorType_'WVL_SYS_Echo(`WVL_Actor_'i`_type')`_logs'))', theLogActors)dnl
ifdef(`theActorLogs',, `define(`theActorLogs', `')')dnl
dnl
WVL_SYS_Foreach(`i', `define(`lognum', 0)WVL_SYS_Foreach(`j', `WVL_SYS_Insert(`theInjectorLogs', i`_'lognum)define(`lognum', incr(lognum))', dnl
WVL_SYS_Echo(`WVL_InjectorType_'WVL_SYS_Echo(`WVL_Actor_'i`_type')`_logs'))', theLogInjectors)dnl
ifdef(`theInjectorLogs',, `define(`theInjectorLogs', `')')dnl
dnl
dnl =============decide the Component Relation that will be used==============
dnl
WVL_SYS_Foreach(`i', dnl
`define(`WVL_ComponentRelation_'WVL_SYS_Echo(`WVL_ComponentRelation_'i`_src')`_'WVL_SYS_Echo(`WVL_ComponentRelation_'i`_name'), dnl
WVL_SYS_Echo(`WVL_ComponentRelation_'i`_dest'))', theRelations)dnl
dnl
dnl =============decide the order to start Components==============
dnl
ifdef(`WVL_ComponentOrder_'WVL_SYS_Echo(`WVL_SUE_'theSUE`_order'), dnl
`define(`theOrder', `WVL_ComponentOrder_'WVL_SYS_Echo(`WVL_SUE_'theSUE`_order')`_sequence')dnl
WVL_SYS_Fortwo(`i', `j', `define(`WVL_Component_'i`_delay', j)', theOrder)', dnl
`WVL_SYS_Foreach(`i', `define(`WVL_Component_'i`_delay', 0)', theComponents)')dnl
dnl
dnl =============decide the CHMap each component will use==============
dnl
WVL_SYS_Foreach(`i', `dnl
define(`WVL_ComponentHost_'WVL_SYS_Echo(`WVL_ComponentHost_'i`_component')`_host', WVL_SYS_Echo(`WVL_ComponentHost_'i`_host'))dnl
define(`WVL_EntityHost_'WVL_SYS_Echo(`WVL_ComponentHost_'i`_component')`_host', WVL_SYS_Echo(`WVL_ComponentHost_'i`_host'))dnl
WVL_SYS_Insert(`WVL_Host_'WVL_SYS_Echo(`WVL_ComponentHost_'i`_host')`_components', WVL_SYS_Echo(`WVL_ComponentHost_'i`_component'))dnl
WVL_SYS_Insert(`theHosts', WVL_SYS_Echo(`WVL_ComponentHost_'i`_host'))', theComponentHosts)dnl
dnl
WVL_SYS_Foreach(`i', `define(`WVL_EntityHost_'i`_host', WVL_SYS_Echo(`WVL_EntityHost_'WVL_SYS_Echo(`WVL_Actor_'i`_entity')`_host'))dnl
WVL_SYS_Insert(`WVL_Host_'WVL_SYS_Echo(`WVL_EntityHost_'i`_host')`_actors', i)dnl
WVL_SYS_Insert(`theDynamicHosts', WVL_SYS_Echo(`WVL_EntityHost_'i`_host'))', theActors)dnl
dnl
WVL_SYS_Foreach(`i', `define(`WVL_EntityHost_'i`_host', WVL_SYS_Echo(`WVL_EntityHost_'WVL_SYS_Echo(`WVL_Actor_'i`_entity')`_host'))dnl
WVL_SYS_Insert(`WVL_Host_'WVL_SYS_Echo(`WVL_EntityHost_'i`_host')`_injectors', i)dnl
WVL_SYS_Insert(`theDynamicHosts', WVL_SYS_Echo(`WVL_EntityHost_'i`_host'))', theInjectors)dnl
dnl
WVL_SYS_Foreach(`i', `define(`WVL_EntityHost_'i`_host', WVL_SYS_Echo(`WVL_EntityHost_'WVL_SYS_Echo(`WVL_Monitor_'i`_entity')`_host'))dnl
WVL_SYS_Insert(`WVL_Host_'WVL_SYS_Echo(`WVL_EntityHost_'i`_host')`_monitors', i)', theMonitors)dnl
dnl
WVL_SYS_Insert(`AllHosts', theHosts)dnl
WVL_SYS_Insert(`AllHosts', theDynamicHosts)dnl
dnl
dnl ==============get the componenttypes of this SUE==============
dnl
WVL_SYS_Foreach(`i', dnl
`ifelse(len(`WVL_ComponentType_'WVL_SYS_Echo(`WVL_Component_'i`_type')`_logs'), 0, `', `WVL_SYS_Insert(`theLogComponents', i)')dnl
WVL_SYS_Insert(`WVL_SUE_'theSUE`_componenttypes', dnl
WVL_SYS_Echo(`WVL_Component_'i`_type'))', theComponents)dnl
dnl
ifdef(`theLogComponents',, `define(`theLogComponents', `')')dnl
dnl
WVL_SYS_Foreach(`i', `define(`lognum', 0)WVL_SYS_Foreach(`j', `WVL_SYS_Insert(`theComponentLogs', i`_'lognum)define(`lognum', incr(lognum))', dnl
WVL_SYS_Echo(`WVL_ComponentType_'WVL_SYS_Echo(`WVL_Component_'i`_type')`_logs'))', theLogComponents)dnl
ifdef(`theComponentLogs',, `define(`theComponentLogs', `')')dnl
dnl
dnl =============assign the backup hosts==============
dnl
WVL_SYS_Foreach(`i', `ifelse(WVL_SYS_Contains(i, AllHosts), `true', , `define(`theBackupHost', i)')', WVL_SYS_Echo(`WVL_Testbed_'theTestbed`_hosts'))dnl
dnl
dnl =============decide the number of Actors==============
dnl
define(`ActorNum', 0)dnl
WVL_SYS_Foreach(`i', `define(`ActorNum', incr(ActorNum))', theActors)dnl
WVL_SYS_Foreach(`i', `define(`ActorNum', incr(ActorNum))', theInjectors)dnl
define(`HostNum', 0)dnl
WVL_SYS_Foreach(`i', `define(`HostNum', incr(HostNum))', AllHosts)dnl

