dnl -*- m4 -*-
dnl
dnl  This file is part of WEEVIL.
dnl
dnl  Authors: See the file AUTHORS for full details.
dnl
dnl  Copyright (C) 2002-2006 University of Colorado
dnl
dnl  Weevil is free software: you can redistribute it and/or modify
dnl  it under the terms of the GNU General Public License as published by
dnl  the Free Software Foundation, either version 3 of the License, or
dnl  (at your option) any later version.
dnl
dnl  Weevil is distributed in the hope that it will be useful,
dnl  but WITHOUT ANY WARRANTY; without even the implied warranty of
dnl  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
dnl  GNU General Public License for more details.
dnl
dnl  You should have received a copy of the GNU General Public License
dnl  along with Weevil.  If not, see <http://www.gnu.org/licenses/>.
dnl
dnl
dnl
dnl ======================control==========================
dnl
define(`forloop',`pushdef(`$1',`$2')_forloop(`$1',`$2',`$3',`$4')popdef(`$1')')dnl
define(`_forloop',`$4`'ifelse($1, `$3',,`define(`$1',incr($1))_forloop(`$1',`$2',`$3',`$4')')')dnl
dnl
define(`WVL_SYS_Range', `ifelse($2, $3, `$1'$2, `ifelse(eval($3>$2), 1, `forloop(`i', $2, decr($3), ``$1'i, ')$1$3', `')')')dnl
dnl
define(`WVL_SYS_Echo', `$1')dnl
dnl
dnl WVL_SYS_Head	-- Returns the "head" of its argument list.
dnl
define( `WVL_SYS_Head', ``$1'')dnl
dnl
dnl WVL_SYS_Tail	-- Returns the "rest" of its argument list.
dnl
define( `WVL_SYS_Tail', `shift($@)')dnl
dnl
dnl WVL_SYS_Add		-- Defines or redefines the first argument to
dnl			   be its previous contents with additional arguments
dnl			   appended.
dnl
define( `WVL_SYS_Add', `ifdef(`$1',`pushdef( `tmp', defn(`$1')`,shift($@)')'`define( `$1', defn(`tmp'))'`popdef(`tmp')',`define(`$1', `shift($@)')')')dnl
dnl
dnl WVL_SYS_Contains	-- Checks if the first argument is contained by the
dnl			   list representing the rest of the arguments
dnl
define( `WVL_SYS_Contains',`ifelse( len(`$2'), 0, `false', `ifelse( `$2', `$1', `true', `WVL_SYS_Contains( `$1', shift(shift($@)))')')')dnl
dnl
dnl WVL_SYS_Insert	-- Adds the second argument to the first argument, if it
dnl		           doesn't already exist there.
define( `WVL_SYS_Insert', `ifelse( len( `$2'), 0, , `ifelse( WVL_SYS_Contains( `$2', $1), `true', , `WVL_SYS_Add( `$1', `$2')')WVL_SYS_Insert( `$1', shift(shift($@)))')')dnl
dnl
dnl WVL_SYS_Callforeach	-- Applies first argument to second argument and
dnl			   then processes the rest recursively
dnl
define( `WVL_SYS_Callforeach',dnl
`ifelse( len($2), 0, , `$1(``$2'')'`WVL_SYS_Callforeach( `$1', shift(shift($@)))')')dnl
dnl
dnl WVL_SYS_Foreach	-- Iterates over arguments 3-* defining $1 to the current value and
dnl			   executing $2.
dnl
dnl WVL_SYS_Foreach( `i', ``i' is set to i', `a', `b', `123', `this,is')
define( `WVL_SYS_Foreach',dnl
`ifelse( len(`$3'), 0, , `pushdef( `$1', `$3')$2`'WVL_SYS_Foreach( `$1', `$2', shift(shift(shift($@))))popdef( `$1')')')dnl
dnl
dnl WVL_SYS_Fortwo      -- Iterates over arguments 4-* defining $1 to the current value and
dnl                        $2 to the next value and executing $3.
dnl
dnl WVL_SYS_Fortwo( `i', `j', ``i' is set to i, `j' is set to j', `a', `b', `123', `this,is')
define( `WVL_SYS_Fortwo',dnl
`ifelse( len(`$3'), 0, , len(`$4'), 0, , `pushdef( `$1', `$4')pushdef( `$2', `$5')$3`'dnl
WVL_SYS_Fortwo( `$1', `$2', `$3', shift(shift(shift(shift(shift($@))))))popdef( `$1')popdef( `$2')')')dnl
dnl
dnl WVL_SYS_Subst_Commas -- Iterates over arguments replacing commas with $1
dnl
define( `WVL_SYS_Subst_Commas',dnl
``$2'`$1'ifelse( len(`$3'), 0, `', `WVL_SYS_Subst_Commas( `$1', shift(shift($@)))')')dnl
dnl
dnl WVL_SYS_Strip_Commas -- Iterates over arguments expanding without commas
dnl
define( `WVL_SYS_Strip_Commas', `WVL_SYS_Subst_Commas( ` ', $@)')dnl
dnl
dnl ============definitions============
dnl
dnl
dnl WVL_SYS_ExternalLibrary
dnl	$1 -- ID
dnl	$2 -- cflags : extra compiler flags needed to use this library
dnl	$3 -- libs   : extra linker flags needed to use this library
dnl	$4 -- path   : any extra directories for the LD_LIBRARY_PATH
dnl
define( `WVL_SYS_ExternalLibrary',`define( `WVL_ExternalLibrary_'$1)dnl
define( `WVL_ExternalLibrary_'$1`_cflags', `$2')dnl
define( `WVL_ExternalLibrary_'$1`_libs', `$3')dnl
define( `WVL_ExternalLibrary_'$1`_path', `$4')')dnl
dnl
dnl WVL_SYS_WorkloadScenario
dnl	$1 -- ID : Workload.ID
dnl	$2 -- length : number of clock ticks in the simulation.
dnl	$3 -- processes : list of WorkloadProcess ids
dnl
define( `WVL_SYS_WorkloadScenario',`define( `WVL_Workload_ID', $1)dnl
define( `WVL_Workload_'$1`_length', `$2')dnl
define( `WVL_Workload_'$1`_processes', `$3')')dnl
dnl
dnl WVL_SYS_WorkloadProcess
dnl	$1 -- ID
dnl	$2 -- type : WorkloadProcessType id
dnl
define( `WVL_SYS_WorkloadProcess',`define( `WVL_WorkloadProcess_'$1)dnl
define( `WVL_WorkloadProcess_'$1`_type', `$2')')dnl
dnl
dnl WVL_SYS_WorkloadProcessProp
dnl	$1 -- workloadProcessID
dnl	$2 -- name : property name
dnl	$3 -- value : property value
dnl
define( `WVL_SYS_WorkloadProcessProp',`define( `WVL_WorkloadProcess_'$1`_'$2, `$3')dnl
WVL_SYS_Insert( `WVL_WorkloadProcess_'$1`_props', $2)')dnl
dnl
dnl
dnl WVL_SYS_WorkloadProcessType
dnl	$1 -- ID
dnl	$2 -- sourceFiles : list of names of source file containing SSim process definition.
dnl	$3 -- libraries : list of external library IDs
dnl
define( `WVL_SYS_WorkloadProcessType',`define( `WVL_WorkloadProcessType_'$1)dnl
define( `WVL_WorkloadProcessType_'$1`_sourceFiles', `$2')dnl
define( `WVL_WorkloadProcessType_'$1`_libraries', `$3')')dnl
dnl
