dnl -*- m4 -*-
dnl
dnl  This file is part of WEEVIL.
dnl
dnl  Authors: See the file AUTHORS for full details.
dnl
dnl  Copyright (C) 2002-2006 University of Colorado
dnl
dnl  Weevil is free software: you can redistribute it and/or modify
dnl  it under the terms of the GNU General Public License as published by
dnl  the Free Software Foundation, either version 3 of the License, or
dnl  (at your option) any later version.
dnl
dnl  Weevil is distributed in the hope that it will be useful,
dnl  but WITHOUT ANY WARRANTY; without even the implied warranty of
dnl  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
dnl  GNU General Public License for more details.
dnl
dnl  You should have received a copy of the GNU General Public License
dnl  along with Weevil.  If not, see <http://www.gnu.org/licenses/>.
dnl
dnl
dnl
changecom( `//', `
')dnl
// this file is automatically created by WEEVIL, do not modify manually
#include <iostream>
#include <siena/ssim.h>
define( `theWorkload', `WVL_Workload_ID')dnl
define( `theProcesses', `WVL_Workload_'theWorkload`_processes')dnl
define( `insertProcessTypes', `WVL_SYS_Insert( `theProcessTypes', WVL_SYS_Echo(WVL_WorkloadProcess_$1_type))')dnl
WVL_SYS_Callforeach( `insertProcessTypes', theProcesses)dnl
define( `insertSourceFiles', `WVL_SYS_Insert( `theSourceFiles', WVL_SYS_Echo(WVL_WorkloadProcessType_$1_sourceFiles))')dnl
WVL_SYS_Callforeach( `insertSourceFiles', theProcessTypes)dnl

// WVL: begin WorkloadProcessType source files
define( `wrapInclude', `#include "$1"
')dnl
WVL_SYS_Callforeach( `wrapInclude', theSourceFiles)dnl
// WVL: end WorkloadProcessType source files

dnl
int main( int argc, char** argv )
{
define( `initializeProcess', `
	WVL_SYS_Echo( `WVL_WorkloadProcess_'$1`_type') $1( "$1" );
	$1.id( "$1" );
	$1.pid( ssim::Sim::create_process( &$1 ) );
	weevil::WeevilGen::add_process( $1.id(), $1.pid() );
')dnl
	// Initialize processes
WVL_SYS_Callforeach( `initializeProcess', theProcesses)dnl

define( `printProperty', `dnl
	$1.$2`(' $3 `)';
')dnl
define( `printProperties',dnl
`ifdef(`WVL_WorkloadProcess_'$1`_props', `WVL_SYS_Foreach( `tmp', `printProperty( $1, tmp, `WVL_WorkloadProcess_'$1`_'tmp)', WVL_SYS_Echo(WVL_WorkloadProcess_$1_props))')')dnl

	// Set properties
WVL_SYS_Callforeach( `printProperties', theProcesses)dnl

	// Start killer process (if necessary)
ifelse( len( `WVL_Workload_'theWorkload`_length'), 0, , dnl
`	ssim::Sim::create_process( new weevil::KillerProcess( WVL_SYS_Echo(`WVL_Workload_'theWorkload`_length') ) );')

	ssim::Sim::run_simulation();
}
